<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Array Functions</title>
</head>

<body>
    <script>
        let cities = [
            {
                name: 'Tallinn',
                country: 'Estonia',
                population: 434562
            },
            {
                name: 'Tartu',
                country: 'Estonia',
                population: 93865
            },
            {
                name: 'Valga',
                country: 'Estonia',
                population: 12992
            },
            {
                name: 'Võru',
                country: 'Estonia',
                population: 12367
            },
            {
                name: 'Helsinki',
                country: 'Finland',
                population: 650058
            },
            {
                name: 'Espoo',
                country: 'Finland',
                population: 284444
            },
            {
                name: 'Hanko',
                country: 'Finland',
                population: 8386
            },
            {
                name: 'Jämsä',
                country: 'Finland',
                population: 20589
            },
            {
                name: 'Stockholm',
                country: 'Sweden',
                population: 972647
            },
            {
                name: 'Uppsala',
                country: 'Sweden',
                population: 168096
            },
            {
                name: 'Lund',
                country: 'Sweden',
                population: 91940
            },
            {
                name: 'Köping',
                country: 'Sweden',
                population: 17743
            }
        ];

        // Massiivimeetodid

        // 1) [].find() - leia esimene, mis sobib
        const cityTartu = cities.find(city => city.name === 'Tartu');
        console.log(cityTartu.population);

        // 2) [].filter() - leia kõik, mis sobivad
        const finlandCities = cities.filter(x => x.country === "Estonia");
        console.log(finlandCities);

        // 3) [].map() - vii kõik elemendid massiivis teisele kujule
        const modifiedCities = cities.map(city => city.name + " / " + city.country.toUpperCase());
        console.log(modifiedCities);

        // 4) [].forEach() - tee kõigi elementidega massiivis midagi (näiteks prindi konsoolile). Ei tagasta midagi!
        cities.forEach(a => console.log(a.name));

        // 5) [].every() - kas vastab tõele, et kõik elemendid kvalifitseeruvad
        const atLeast10000 = cities.every(city => city.population >= 10000);
        console.log(atLeast10000);

        // 6) [].some() - kas vastab tõele, et on vähemalt üks element, mis kvalifitseerub
        const largeCitiesExist = cities.some(city => city.population >= 500000);
        console.log(largeCitiesExist);

        // 7) [].sort() - sorteerib massiivi vastavalt etteantud instruktsioonile
        // Variant 1
        // const sortedCities = cities.sort(
        //     (city1, city2) => {
        //         // kui järjekord on õige, tagasta negatiivne number
        //         // kui objektid on võrdsed, tagasta 0
        //         // kui objektid on vales järjestuses, tagasta mingi suvaline positiivne number
        //         if (city1.population < city2.population) {
        //             return 1;
        //         } else if (city1.population === city2.population) {
        //             return 0;
        //         } else {
        //             return -1;
        //         }
        //     }
        // );
        const sortedCities = cities.sort((c1, c2) => c1.population - c2.population);
        console.log(sortedCities);

        // 8) [].reduce() - agregeeri objektid massiivis kokku kindla reegli alusel
        const totalPopulation = cities.reduce((currentTotal, city) => currentTotal + city.population, 0);
        console.log(totalPopulation);

    </script>
</body>

</html>